Immers = {
	name = "ImmersionToggles",
	version = "100016.001",
	author = "Terrillyn",
	settings_version = 3,
	settings_name = "ImmersionToggles_Settings",
	misc = {},
	AWSV = nil,
	CSV = nil,
	CurSV = nil,
	defaults = {
		useAcctSettings = true,
		transitTime = 5,
		Toggles = {},
	}
}
----------------------------------------------------------------------------------------------------------------------
function Immers._OnAddonLoaded(eventCode, addonName)
	if addonName ~= Immers.name then return end

	Immers.AWSV = ZO_SavedVars:NewAccountWide(Immers.settings_name, Immers.settings_version, nil, Immers.defaults)
	Immers.CSV = ZO_SavedVars:New(Immers.settings_name, Immers.settings_version, nil, Immers.defaults)

	if Immers.AWSV.useAcctSettings then
		Immers.CSV.version = nil
		Immers.CurSV = Immers.AWSV
		Immers.CSV = ZO_SavedVars:New(Immers.settings_name, Immers.settings_version, nil, ImmersionToggles_Settings['Default'][GetDisplayName()]['$AccountWide'])
	else
		Immers.CurSV = Immers.CSV
	end
	
	EVENT_MANAGER:UnregisterForEvent(Immers.name, EVENT_ADD_ON_LOADED)
	EVENT_MANAGER:RegisterForEvent(Immers.name, EVENT_PLAYER_ACTIVATED, Immers._OnPlayerActivated)
end

function Immers._OnPlayerActivated(eventCode)
	--- add built-in elements
	for _,item in pairs(Immers._LoadElements()) do
		Immers._AddNewCustomElement(item)
	end

	--- init some vars
	Immers.misc.transitTime = (Immers.CurSV.transitTime * 1000) or 5000
	
	--- REGISTER PLAYERSTATEUPDATE EVENT
	EVENT_MANAGER:RegisterForUpdate(Immers.name .. "._UpdateInternalStates", 50, Immers._UpdateInternalStates)

	--- CREATE SETTINGS MENU
	Immers._CreateSettingsMenu()

	Immers._SetupConditionalEvents()

	--- UNREGISTER THIS
	EVENT_MANAGER:UnregisterForEvent(Immers.name, EVENT_PLAYER_ACTIVATED)

	--- CHECK API
	--Terril_lib.IsAddonOutOfDate(Immers, true)
	collectgarbage()
end
----------------------------------------------------------------------------------------------------------------------
Immers._EvaluateConditions = function(element_name)
	local ElementSettings = Immers.CurSV.Toggles[element_name]
	if not ElementSettings then return true end

	for k,v in pairs(ElementSettings.alwaysHide) do
		if Immers.InternalConditions[k] then return false end
	end
	for k,v in pairs(ElementSettings.showWhen) do
		if Immers.InternalConditions[k] then return true end
	end
	for k,v in pairs(ElementSettings.hideWhen) do
		if Immers.InternalConditions[k] then return false end
	end

	return true
end

Immers._UpdateItems = function()
	for _,element_data in pairs(Immers.Elements) do
		if element_data.enabled == true then element_data:updateFunc() end
	end
end

function Immers._ValidateElementTable(data)
	assert(type(data) == "table", "custom data is not a table")
	assert(type(data.disableFunc) == "function", "table doesnt contain valid function:disableFunc.")
	assert(type(data.enableFunc) == "function", "table doesnt contain valid function:enableFunc.")
	assert(type(data.updateFunc) == "function", "table doesnt contain valid function:updateFunc.")
	assert(type(data.name) == "string", "table doesnt contain valid string:name.")
	assert(type(data.enabled) == "boolean", "table doesnt contain valid bool:enabled")
end

function Immers._AddNewCustomElement(data)
	Immers._ValidateElementTable(data)
	
	if not Immers.CurSV.Toggles[data.name] then
		Immers.CurSV.Toggles[data.name] = {
								enabled = false,
								showWhen = {},
								hideWhen = {},
								alwaysHide = { GAMEMENU = true, MOUSE = true, INTERACT = true }
							}
	end

	if not Immers.Elements then Immers.Elements = {} end

	Immers.Elements[data.name] = data

	if Immers.CurSV.Toggles[data.name].disabled == false then
		data:enableFunc()
	end
end
----------------------------------------------------------------------------------------------------------------------
EVENT_MANAGER:RegisterForEvent(Immers.name, EVENT_ADD_ON_LOADED, Immers._OnAddonLoaded)